package test;

import java.util.HashMap;
import java.util.Map;

public class QuestData {

  private final Map<String, String> properties;

  public QuestData() {
    properties = new HashMap<>();
  }

  // Properties

  public Map<String, String> getProperties() {
    return properties;
  }

  // Methods

  public void addProperty(String key, String value) {
    if (!properties.containsKey(key)) {
      properties.put(key, value.trim());
    }
  }

  public void appendProperty(String key, String value) {
    if (properties.containsKey(key)) {
      String current = properties.get(key);
      if (!current.contains(value)) {
        properties.put(key, current + ',' + value.trim());
      }
    }
    else {
      properties.put(key, value.trim());
    }
  }

  public String getProperty(String key) {
    return properties.get(key);
  }

  public boolean hasProperty(String key) {
    return properties.containsKey(key);
  }

  @Override
  public String toString() {
    StringBuilder buf = new StringBuilder();
    int id = Integer.parseInt(properties.get("QuestId"));
    buf.append(String.format("q%08X = { ", id));
    buf.append("name = \"").append(properties.get("Name")).append('\"');
    /*
    if (hasProperty("Scope")) {
      buf.append(", scope = \"").append(properties.get("Scope")).append('\"');
    }
    */
    if (hasProperty("Faction")) {
      buf.append(", faction = \"").append(properties.get("Faction")).append('\"');
    }
    if (hasProperty("Scene")) {
      buf.append(", scene = \"").append(properties.get("Scene")).append('\"');
    }
    //buf.append(", zone = \"").append(properties.get("Zone")).append('\"');
    //buf.append(", repeatable = \"").append(properties.get("Repeatable")).append('\"');
    buf.append(" }");
    return buf.toString();
  }

}
