package test;

import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParserFactory;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class QuestParser {

  private static void parse(String filename) throws IOException, ParserConfigurationException, SAXException {
    try (Reader input = new BufferedReader(new FileReader(filename))) {
      XMLReader reader = SAXParserFactory.newInstance().newSAXParser().getXMLReader();
      Map<String, List<QuestData>> quests = new HashMap<>();
      reader.setContentHandler(new SaxParser(quests));
      reader.parse(new InputSource(input));
      System.out.println("local data = {");
      for (Map.Entry<String, List<QuestData>> entry : quests.entrySet()) {
        System.out.println("\t[\"" + entry.getKey() + "\"] = {");
        for (QuestData data : entry.getValue()) {
          System.out.println("\t\t" + data.toString() + ",");
        }
        System.out.println("\t},");
      }
      System.out.println("}");
    }
  }

  public static void main(String[] args) {
    try {
      if (args.length == 0) {
        System.out.println("Usage: QuestParser <questFile>");
      }
      else {
        parse(args[0]);
      }
    }
    catch (Exception e) {
      System.out.println("Exception: " + e.getMessage());
    }
  }

}
