package test;

import java.util.ArrayList;
import java.util.List;

public class SaxPath {

  private static final int DEFAULT_LENGTH = 64;

  private final List<String> path;

  public SaxPath() {
    path = new ArrayList<>();
  }

  // Properties

  public int length() {
    return path.size();
  }

  // Methods

  public void push(String element) {
    path.add(element);
  }

  public void pop() {
    path.remove(path.size() - 1);
  }

  @Override
  public String toString() {
    StringBuilder buf = new StringBuilder(DEFAULT_LENGTH);
    buf.append('/');
    if (!path.isEmpty()) {
      for (String element : path) {
        buf.append(element).append('/');
      }
      buf.setLength(buf.length() - 1);
    }
    return buf.toString();
  }

  public boolean equals(String strPath) {
    return toString().equals(strPath);
  }

}
